<template>
	<view class="container">
		<!-- <image src="" mode=""></image> -->
		<!-- 顶部logo and 搜索 start-->
		<view class="index-top-wrap">
			<image src="../../static/index/index-top.png" mode="widthFix" class="index-top"></image>
			<view class="status_bar fud"></view>
			<view class="top-search flex fud">
				<view class="search-box flex" @click="clickSearch()">
					<image class="search" src="../../static/icon/search-h.png" mode=""></image>
					<view class="search-font">输入关键词搜索</view>
				</view>
			</view>
			<!-- 顶部logo and 搜索 end-->
			<!-- <view class="jg fud" style="background-color: #fff;"></view> -->
			<!-- 轮播图 start -->
			<swiper class="top-swiper fud" autoplay="true" duration="400" interval="5000" @change="swiperChange">
				<swiper-item v-for="(item, index) in carouselList" :key="index" class="carousel-item"
					@click="bannerNavToUrl(item)">
					<image :src="item.pic" />
				</swiper-item>
			</swiper>
			<!-- 轮播图 end -->
		</view>
		<!-- 分类 start -->
		<view class="cate-section flex">
			<view class="cate-item flex" @click="navto('/pages/category/category')">
				<view class="img-wrapper flex">
					<image src="../../static/index/in1.png" mode=""></image>
				</view>
				<view class="item-title">全部商品</view>
			</view>
			<view class="cate-item flex" @click="navto('/pages/index/artDetail?id=1')">
				<view class="img-wrapper flex">
					<image src="../../static/index/in2.png" mode=""></image>
				</view>
				<view class="item-title">公司介绍</view>
			</view>
			<view class="cate-item flex" @click="openKf">
				<view class="img-wrapper flex">
					<image src="../../static/index/in3.png" mode=""></image>
				</view>
				<view class="item-title">联系客服</view>
			</view>
			<view class="cate-item flex" @click="navto('/pages/index/storeList')">
				<view class="img-wrapper flex">
					<image src="../../static/index/in6.png" mode=""></image>
				</view>
				<view class="item-title">本地门店</view>
			</view>
			<view class="cate-item flex" @click="navto('/pages/user/shareQrCode',1)">
				<view class="img-wrapper flex">
					<image src="../../static/index/in4.png" mode=""></image>
				</view>
				<view class="item-title">邀请好友</view>
			</view>
			<view class="cate-item flex" @click="navto('/pages/index/artDetail?id=2')">
				<view class="img-wrapper flex">
					<image src="../../static/index/in7.png" mode=""></image>
				</view>
				<view class="item-title">加入我们</view>
			</view>
		</view>
		<!-- 分类 ed -->
		<view class="jg">

		</view>
		<view class="hdlist" >
			<image src="../../static/index/ryc.png" @click="navTo('/pages/index/actionDetail?id=1')" mode="widthFix"></image>
			<image src="../../static/index/xny.png" @click="navTo('/pages/index/actionDetail?id=2')" mode="widthFix"></image>
		</view>
		<!-- 商品列表 start -->
		<view class="product-box">
			<view class="product-tit flex">
				<view class="hx">
			
				</view>
				<view class="tit">
					热销推荐
				</view>
				<view class="hx">
			
				</view>
			</view>
		</view>
		<view class="good-list">
			<view class="good" v-for="item in goodList" @click="navTo('/pages/product/product?id=' + item.id)">
				<image :src="item.image" mode="" class="good-image"></image>
				<view class="good-name ">
					<view class="clamp">
						{{item.store_name}}
					</view>
				</view>
				<view class="good-key">
					鸿运开来 为成功喝彩
				</view>
				<view class="good-price">
					<view class="price">
						￥{{item.price}}
					</view>
					<view class="xl">
						销量：{{item.sales}}
					</view>
				</view>
			</view>
		</view>
		<!-- 商品列表 ed-->
		<uni-popup ref="popupkf" type="center">
			<view class="popup-box">
				<view class="img">
					<image src="../../static/img/img009.png" mode=""></image>
				</view>
				<view class="mian">
					<view class="delivery">
						<view class="title">已经为您定制专属客服</view>
						<image src="../../static/img/img010.png" mode=""></image>
					</view>
					<view class="nocancel">客服VX:{{ text }}</view>
					<view class="comfirm-box">
						<view class="cancel" @click="cancel">取消</view>
						<view class="comfirm" @click="comfirm(text)">复制微信</view>
					</view>
				</view>
			</view>
		</uni-popup>
	</view>
</template>

<script>
	import {
		loadIndexs
	} from '@/api/index.js';
	import {
		getUserInfo,
		spread
	} from '@/api/user.js';
	import {
		getBargainList,
		getProducts,
		goodsDetail,
		poster
	} from '@/api/product.js';
	import {
		saveUrl,
		interceptor
	} from '@/utils/loginUtils';
	import {
		mapState,
		mapMutations
	} from 'vuex';
	// #ifdef H5
	import {
		weixindata,
		shareLoad
	} from '@/utils/wxAuthorized';
	// #endif
	export default {
		data() {
			return {
				text: 'shxsophina', //客服微信
				page: 1,
				limitt: 20,
				loadingType: 'more',
				current: 0,
				shareShow: false, //分享海报
				pageProportion: 0, //保存页面基于750宽度的比例
				swiperHeight: 0,
				checkid: 0,
				titleNViewBackground: '',
				swiperCurrent: 0,
				swiperLength: 0,
				carouselList: [], //轮播列表
				page: 1,
				limit: 5,
				firstList: [],
				goodList: [], //商品列表
				shopList: [],
				period: 1,
				shareImage: '',
			};
		},
		computed: {
			...mapState('user', ['hasLogin', 'userInfo'])
		},
		onShareAppMessage(options) {
			// 设置菜单中的转发按钮触发转发事件时的转发内容
			let pages = getCurrentPages(); //获取加载的页面
			let currentPage = pages[pages.length - 1]; //获取当前页面的对象
			let url = currentPage.route; //当前页面url
			let item = currentPage.options; //如果要获取url中所带的参数可以查看options
			let shareObj = {}
			if (this.userInfo.uid) {
				shareObj = {
					title: this.userInfo.nickname + '邀请您加入顺肠清', // 默认是小程序的名称(可以写slogan等)
					path: url + '?scene=' + this.userInfo.uid, // 默认是当前页面，必须是以‘/’开头的完整路径
					imageUrl: '',
					success: function(res) {
						// 转发成功之后的回调
						if (res.errMsg == 'shareAppMessage:ok') {}
					},
					fail: function() {
						// 转发失败之后的回调
						if (res.errMsg == 'shareAppMessage:fail cancel') {
							// 用户取消转发
						} else if (res.errMsg == 'shareAppMessage:fail') {
							// 转发失败，其中 detail message 为详细失败信息
						}
					}
				};
			} else {
				shareObj = {
					title: '顺肠清', // 默认是小程序的名称(可以写slogan等)
					path: url, // 默认是当前页面，必须是以‘/’开头的完整路径
					imageUrl: '',
					success: function(res) {
						// 转发成功之后的回调
						if (res.errMsg == 'shareAppMessage:ok') {}
					},
					fail: function() {
						// 转发失败之后的回调
						if (res.errMsg == 'shareAppMessage:fail cancel') {
							// 用户取消转发
						} else if (res.errMsg == 'shareAppMessage:fail') {
							// 转发失败，其中 detail message 为详细失败信息
						}
					}
				};
			}

			return shareObj;
		},
		onReachBottom() {
			console.log('到底')
			this.getGoodList()
		},
		onLoad: function(option) {
			// #ifdef MP
			if (option.scene) {
				// 存储小程序邀请人
				uni.setStorage({
					key: 'spread_code',
					data: option.scene
				});
			}
			// #endif
		},
		onShow: function() {
			this.getGoodList()
			this.loadData();
		},
		methods: {
			getGoodList() {
				let obj = this
				if (obj.loadingType == 'loading' || obj.loadingType == 'noMore') {
					return
				}
				obj.loadingType = 'loading'
				getProducts({
					page: 1,
					limit: 50,
				}).then(res => {
					obj.goodList = obj.goodList.concat(res.data)
					if (obj.limit == res.data.length) {
						obj.loadingType = 'more'
					} else {
						obj.loadingType = 'noMore'
					}
				})
			},
			navto(url, type = 0) {
				if (type == 1) {
					if (!this.hasLogin) {
						// 保存地址
						saveUrl();
						// 登录拦截
						interceptor();
					} else {
						uni.navigateTo({
							url,
							fail() {
								uni.switchTab({
									url
								})
							}
						})
					}
				} else {
					uni.navigateTo({
						url,
						fail() {
							uni.switchTab({
								url
							})
						}
					})
				}

			},
			navTo(url) {
				if (url == '') {
					this.$api.msg('暂未开通，敬请期待');
				} else {
					this.navto(url)
				}
			},
			// 點擊搜索框
			clickSearch() {
				uni.navigateTo({
					url: '/pages/product/search'
				});
			},
			// 监听图片加载完成
			onImageError(key, index) {
				this[key][index].image = '/static/error/errorImage.jpg';
			},
			// 请求载入数据
			async loadData() {
				loadIndexs({})
					.then(({
						data
					}) => {
						let goods = data.info;
						console.log(goods, '商品信息');
						this.carouselList = data.banner;
						this.swiperLength = this.carouselList.length;
						this.bastList = data.giftInfo; //会员礼包
						data.info.firstList.forEach(e => {
							e.isVip = e.store_type ? "3" : "0"
						})
						this.firstList = data.info.firstList //首页商品
						uni.stopPullDownRefresh();
					})
					.catch(e => {
						uni.stopPullDownRefresh();
					});
			},
			//轮播图切换修改背景色
			swiperChange(e) {
				const index = e.detail.current;
				this.swiperCurrent = index;
				this.titleNViewBackground = this.carouselList[index].background;
			},
			// 轮播图跳转
			bannerNavToUrl(item) {
				// #ifdef H5
				console.log(item.wap_url.indexOf('http'), 'banner');
				if (item.wap_url.indexOf('http') >= 0) {
					window.location.href = item.wap_url;
				}
				// #endif
				//测试数据没有写id，用title代替
				uni.navigateTo({
					url: item.wap_url
				});
			},
			comfirm(text) {
				console.log(text);
				const result = this.uniCopy(text);
				if (result === false) {
					uni.showToast({
						title: '不支持'
					});
				} else {
					uni.showToast({
						title: '复制成功',
						icon: 'none'
					});
				}
				this.$refs.popupkf.close();
			},
			uniCopy(content) {
				/**
				 * 小程序端 和 app端的复制逻辑
				 */
				//#ifndef H5
				uni.setClipboardData({
					data: content,
					success: function() {
						console.log('success');
						return true;
					}
				});
				//#endif

				/**
				 * H5端的复制逻辑
				 */
				// #ifdef H5
				if (!document.queryCommandSupported('copy')) {
					//为了兼容有些浏览器 queryCommandSupported 的判断
					// 不支持
					return false;
				}
				let textarea = document.createElement('textarea');
				textarea.value = content;
				textarea.readOnly = 'readOnly';
				document.body.appendChild(textarea);
				textarea.select(); // 选择对象
				textarea.setSelectionRange(0, content.length); //核心
				let result = document.execCommand('copy'); // 执行浏览器复制命令
				textarea.remove();
				return result;
				// #endif
			},
			// 打开客服
			openKf() {
				this.$refs.popupkf.open();
			},
			// 关闭客服
			cancel() {
				this.$refs.popupkf.close();
			},
		}
	};
</script>

<style lang="scss">
	page {
		background: #ffff;
		min-height: 100%;
		height: auto;
	}

	// 顶部搜索
	.top-search {
		height: 80rpx;
		padding: 0 20rpx;
		margin-bottom: 20rpx;
		// background-color: #fff;

		.top-logo {
			width: 50rpx;
			// height: 50rpx;
			margin-right: 10rpx;

			image {
				width: 48rpx;
			}

		}

		.search-box {
			justify-content: center;
			width: 698rpx;
			height: 60rpx;
			background: #EEEEEE;
			// box-shadow: 0px 10rpx 20rpx 0px rgba(4, 114, 69, 0.22);
			border-radius: 30rpx;

			.search {
				width: 34rpx;
				height: 34rpx;
			}

			.search-font {
				margin-left: 14rpx;
				font-size: 28rpx;
				font-family: PingFang SC;
				font-weight: 500;
				color: #CBCBCB;
			}
		}
	}

	// 顶部轮播图
	.top-swiper {
		width: 690rpx;
		height: 365rpx;

		// margin: 20rpx 0 0;
		border-radius: 20rpx;
		margin: auto;
		image {
			width: 690rpx;
			height: 365rpx;
			border-radius: 20rpx;
		}
	}

	.swiper-btm {
		height: 60rpx;
		width: 750rpx;
		background-color: #fff;
		margin-bottom: 20rpx;
		font-size: 21rpx;
		font-weight: 500;
		color: #333333;

		.btm-item {
			flex-grow: 1;
			justify-content: center;

			image {
				width: 25rpx;
				height: 25rpx;
				margin-right: 14rpx;
			}
		}
	}

	.jg {
		height: 20rpx;
		background: #fff;
	}

	// 分类
	.cate-section {
		justify-content: space-around;
		background-color: #fff;
		padding: 0rpx 0 10rpx;
		margin-top: 20rpx;
		flex-wrap: wrap;
		.cate-item {
			flex-grow: 0;
			width: 33.3%;
			flex-direction: column;
			text-align: center;
			align-items: center;
			justify-content: center;
			padding-bottom: 20rpx;
			.img-wrapper {
				width: 90rpx;
				height: 90rpx;
				border-radius: 20rpx;
				position: relative;

				image {
					width: 90rpx;
					height: 90rpx;
					position: absolute;
					left: 50%;
					top: 50%;
					transform: translate(-50%, -50%);
				}
			}

			.item-title {
				margin-top: 15rpx;
				font-size: 26rpx;
				font-weight: 500;
				color: #6B4216;
			}
		}
	}

	.product-box {
		margin-top: 20rpx;
		background: #ffffff;
		padding: 26rpx 0 20rpx;
		.product-tit {
			justify-content: center;
		
			.hx {
				width: 120rpx;
				height: 1rpx;
				background: #4A2723;
			}
		
			.tit {
				margin: 0 70rpx;
				font-size: 30rpx;
				font-weight: 500;
				color: #4A2723;
			}
		}
	}

	.hotgoods {
		margin-top: 38rpx;
		width: 100%;
		display: flex;
		flex-wrap: wrap;
		padding: 0 20rpx 30rpx;
		justify-content: space-between;

		.hotgoods-item {
			width: 345rpx;
			background-color: #ffffff;
			border-radius: 12rpx;
			box-shadow: 0 0 15rpx rgba(0, 0, 0, 0.2);
			margin-bottom: 15rpx;

			.image-wrapper {
				width: 345rpx;
				height: 345rpx;
				border-radius: 3px;
				overflow: hidden;
				position: relative;

				.image-bg {
					position: absolute;
					top: 0;
					left: 0;
					right: 0;
					bottom: 0;
					width: 100%;
					height: 100%;
					opacity: 1;
					border-radius: 12rpx 12rpx 0 0;
					z-index: 2;
				}

				.image {
					width: 100%;
					height: 100%;
					opacity: 1;
					border-radius: 12rpx 12rpx 0 0;
				}
			}

			.title {
				margin-top: 24rpx;
				padding: 0 20rpx;
				font-size: 28rpx;
				font-family: PingFang SC;
				font-weight: 500;
				color: #333333;
			}

			.hot-price {
				display: flex;
				justify-content: flex-start;
				align-items: center;
				// padding: 14rpx 0 30rpx;

				.hotPrice-box {
					padding: 2rpx 6rpx;

					background: linear-gradient(90deg, #c79a4c, #f9df7f);
					border-radius: 5rpx;
					text-align: center;
					line-height: 28rpx;
					font-size: 20rpx;
					font-family: Source Han Sans CN;
					font-weight: 400;
					color: #ffffff;
				}

				.price {
					margin-left: 10rpx;
					font-size: 40rpx;
					color: #ff0000;
					font-weight: 500;

					.jf {
						font-size: 20rpx;
					}
				}

				.yuanPrice {
					margin-left: 10rpx;
					font-size: 20rpx;
					font-family: PingFang SC;
					font-weight: 500;
					text-decoration: line-through;
					color: #999999;
				}

				.cart-icon {
					image {
						width: 44rpx;
						height: 44rpx;
					}
				}
			}
		}
	}

	.popup-box {
		width: 522rpx;
		height: 605rpx;
		background-color: #ffffff;
		border-radius: 20rpx;
		position: relative;
		.product-tit {
			justify-content: center;
		
			.hx {
				width: 120rpx;
				height: 1rpx;
				background: #989898;
			}
		
			.tit {
				margin: 0 70rpx;
				font-size: 30rpx;
				font-weight: 500;
				color: #4A2723;
			}
		}
		.img {
			position: relative;
			top: -56rpx;
			left: 0;
			width: 522rpx;
			height: 132rpx;
			display: flex;
			justify-content: center;

			image {
				border-radius: 20rpx 20rpx 0 0;
				width: 450rpx;
				height: 132rpx;
			}
		}

		.mian {
			margin-top: -44rpx;
			display: flex;
			flex-direction: column;
			align-items: center;
			// padding: 32rpx 32rpx;
			background-color: #ffffff;
			border-radius: 0 0 20rpx 20rpx;
			text-align: center;

			.delivery {
				font-size: 40rpx;
				color: #333333;
				display: flex;
				align-items: center;
				flex-direction: column;

				image {
					margin-top: 48rpx;
					width: 172rpx;
					height: 160rpx;
				}
			}

			.nocancel {
				font-size: 32rpx;
				color: #333333;
				margin-top: 14rpx;
			}

			.comfirm-box {
				margin-top: 52rpx;
				display: flex;
				// margin-bottom: 32rpx;

				// justify-content: space-around;
				.cancel {
					display: flex;
					align-items: center;
					justify-content: center;
					width: 197rpx;
					height: 74rpx;
					border: 1px solid #dcc786;
					border-radius: 38rpx;

					font-size: 32rpx;
					color: #605128;
				}

				.comfirm {
					margin-left: 32rpx;
					display: flex;
					align-items: center;
					justify-content: center;
					width: 197rpx;
					height: 74rpx;
					background: linear-gradient(-90deg, #d1ba77 0%, #f7e8ad 100%);
					border-radius: 38px;
					font-size: 32rpx;
					color: #605128;
				}
			}
		}
	}
	.good-list {
		display: flex;
		justify-content: space-between;
		flex-wrap: wrap;
		padding: 20rpx 28rpx;
		.good {
			width: 336rpx;
			height: 482rpx;
			background: #FFFFFF;
			box-shadow: 0px 0px 6rpx 0px rgba(0, 0, 0, 0.1);
			border-radius: 14rpx;
			margin-bottom: 20rpx;
			position: relative;
			.good-image {
				width: 336rpx;
				height: 336rpx;
				background-color: #eee;
				border-radius: 14rpx 14rpx 0 0;
			}
	
			.good-name {
				font-size: 28rpx;
				font-weight: bold;
				color: #333333;
				padding: 0 20rpx;
			}
			.good-key {
				font-size: 22rpx;
				font-weight: 500;
				color: #999999;
				padding-left: 20rpx
			}
			.good-price {
				display: flex;
				width: 336rpx;
				justify-content: space-between;
				font-size: 28rpx;
				font-weight: bold;
				color: #FF1A1A;
				position: absolute;
				bottom: 20rpx;
				padding: 0 20rpx;
				.xl{
					font-size: 20rpx;
					font-weight: bold;
					color: #999999;
				}
			}
		}
	}
	// .good-list {
	// 	width: 750rpx;
	// 	background:#fff;
	// 	padding: 30rpx 0;
	
	// 	.good {
	// 		width: 690rpx;
	// 		height: 276rpx;
	// 		background: #FFFFFF;
	// 		box-shadow: 0px 0px 20rpx 0px rgba(50, 50, 52, 0.06);
	// 		border-radius: 10rpx;
	// 		margin: auto;
	// 		padding: 20rpx 15rpx;
	// 		margin-bottom: 20rpx;
	// 		&:last-of-type {
	// 			margin-bottom: 0rpx;
	// 		}
	
	// 		.good-img {
	// 			flex-shrink: 0;
	// 			width: 236rpx;
	// 			height: 236rpx;
	// 			border-radius: 10rpx;
	// 			margin-right: 22rpx;
	
	// 			image {
	// 				width: 236rpx;
	// 				height: 236rpx;
	// 				border-radius: 10rpx;
	// 			}
	// 		}
	
	// 		.good-info {
	// 			flex-grow: 1;
	// 			height: 100%;
	// 			flex-direction: column;
	// 			justify-content: space-between;
	// 			align-items: flex-start;
	
	// 			.good-name {
	// 				font-size: 32rpx;
	// 				font-weight: bold;
	// 				padding-top: 10rpx;
	// 				color: #333333;
	// 			}
	
	// 			.good-price {
	// 				width: 100%;
	
	// 				image {
	// 					width: 14rpx;
	// 					margin: 0 6rpx 0 10rpx;
	// 				}
	
	// 				.old-price {
	// 					.old-left {
	// 						font-size: 26rpx;
	// 						font-weight: 500;
	// 						text-decoration: line-through;
	// 						color: #999999;
	// 					}
	
	// 					.old-right {
	// 						font-size: 24rpx;
	// 						font-weight: bold;
	// 						color: #B59467;
	// 					}
	// 				}
	
	// 				.new-price {
	// 					width: 100%;
	// 					font-size: 36rpx;
	// 					font-weight: bold;
	// 					color: #FF4C4C;
	// 					justify-content: space-between;
	
	// 					.good-tip {
	// 						width: 137rpx;
	// 						height: 52rpx;
	// 						background: #ff4a48;
	// 						border-radius: 26rpx;
	// 						position: relative;
	// 						font-size: 26rpx;
	// 						font-weight: 500;
	// 						color: #FFFFFF;
	// 						line-height: 52rpx;
	// 						text-align: center;
	// 					}
	// 				}
	// 			}
	// 		}
	// 	}
	
	// }
	.index-top-wrap {
		position: relative;
		.index-top {
			width: 750rpx;
			position: absolute;
		}
		.fud {
			position: relative;
		}
	}
	.hdlist {
		width: 100%;
		image {
			display: block;
			width: 705rpx;
			margin: 25rpx auto;
		}
	}
</style>
